package net.jorgemanrubia.emfcomparison;

import java.io.IOException;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.UMLPackage;
import org.eclipse.uml2.uml.resource.UMLResource;

public class Main {
	private final static String MODEL_1_FILE_NAME = "model1.uml";
	private final static String MODEL_2_FILE_NAME = "model2.uml";
	private final static String MODELS_FOLDER = "model";
	
	private static ResourceSet createResourceSet(){
		ResourceSet resourceSet = new ResourceSetImpl();
		resourceSet.getPackageRegistry().put(UMLPackage.eNS_URI, UMLPackage.eINSTANCE);

		resourceSet.getResourceFactoryRegistry().getExtensionToFactoryMap().put(UMLResource.FILE_EXTENSION, UMLResource.Factory.INSTANCE);

		return resourceSet;
	}

	private static EList<EObject> loadUMLModel(String modelFileName) throws IOException{
		ResourceSet resourceSet = createResourceSet();
		URI uri = URI.createFileURI(MODELS_FOLDER+"/"+modelFileName);
		Resource resource = resourceSet.createResource(uri);
		resource.load(null);
		return resource.getContents();
	}
	
	/**
	 * @param args
	 * @throws IOException 
	 */
	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub

		EList<EObject> model1 = loadUMLModel(MODEL_1_FILE_NAME);
		EList<EObject> model2 = loadUMLModel(MODEL_2_FILE_NAME);
		
		EMFComparator emfComparator = new EMFComparator();
		System.out.println("Equals: "+emfComparator.equals(model1, model2));
	}

}
